/*
 * tokenizer for Dumbo Basic.
 *
 * DO NOT EDIT THIS FILE BY HAND, EXCEPT AS DESCRIBED BELOW -
 * MOST OF THIS FILE IS GENERATED FROM tokenizer.pl USING PERL
 *
 * You can get ActivePerl for Windows from:
 *     http://www.activestate.com/activeperl/
 *
 * To create the contents of this "parse_token" procedure, run 
 * the tokenizer perl script as "perl tokenizer.pl > xxx" and
 * then paste the xxx output into the section indicated below.
 *
 * Then make the following amendments manually: 
 *
 * 1. ensure that all occurrences of "$;" are replaced with 
 *    "STRING;" (perl creates identifiers invalid in C).
 *
 * 2. There are six places that must be manually amended:
 *    'A' 'S'     should return AS  - see line 126 below
 *    'D' 'E' 'F' should return DEF - see line 392 below
 *    'E' 'R' 'R' should return ERR - see line 488 below
 *    'L' 'O' 'C' should return LOC - see line 761 below
 *    'E' 'O' 'F' should return xEOF - see line 440 below
 *    'I' 'N' 'P' 'U' 'T' should return INPUT - see line 666 below
 *    (Perl can't handle identifiers that are substrings of
 *     another identifer, or that are already defined by C)
 *
 * To add new tokens, define them in tokens.h, them add them to
 * the "tokenizer.pl" script - then run the script. Note that
 * the perl script uses C.pm, which must first be installed in
 * the perl site libray (e.g. C:\Perl\site\lib\Devel\Tokenizer).
 *  
 * Also, don't forget to add them to the 'tokenlen' procedure!
 *
 */
#include "tokens.h"

int token_parser(unsigned char *tokstr) {

/* --------------------------------- PASTE -----------------------------------*/
   switch (tokstr[0])
   {
     case 'A':
     case 'a':
       switch (tokstr[1])
       {
         case 'B':
         case 'b':
           if ((tokstr[2] == 'S' || tokstr[2] == 's'))
           {                                      /* ABS       */
             return ABS;
           }

           goto unknown;

         case 'C':
         case 'c':
           switch (tokstr[2])
           {
             case 'C':
             case 'c':
               if ((tokstr[3] == 'E' || tokstr[3] == 'e') &&
                   (tokstr[4] == 'S' || tokstr[4] == 's') &&
                   (tokstr[5] == 'S' || tokstr[5] == 's'))
               {                                  /* ACCESS    */
                 return ACCESS;
               }

               goto unknown;

             case 'O':
             case 'o':
               if ((tokstr[3] == 'S' || tokstr[3] == 's'))
               {                                  /* ACOS      */
                 return ACOS;
               }

               goto unknown;

             default:
               goto unknown;
           }

         case 'N':
         case 'n':
           if ((tokstr[2] == 'D' || tokstr[2] == 'd'))
           {                                      /* AND       */
             return AND;
           }

           goto unknown;

         case 'P':
         case 'p':
           if ((tokstr[2] == 'P' || tokstr[2] == 'p') &&
               (tokstr[3] == 'E' || tokstr[3] == 'e') &&
               (tokstr[4] == 'N' || tokstr[4] == 'n') &&
               (tokstr[5] == 'D' || tokstr[5] == 'd'))
           {                                      /* APPEND    */
             return APPEND;
           }

           goto unknown;

         case 'S':
         case 's':
           switch (tokstr[2])
           {
             case 'C':
             case 'c':
               {                                  /* ASC       */
                 return ASC;
               }

             case 'I':
             case 'i':
               if ((tokstr[3] == 'N' || tokstr[3] == 'n'))
               {                                  /* ASIN      */
                 return ASIN;
               }

               goto unknown;

             default:
               return AS; // manually added
               // goto unknown
           }

         case 'T':
         case 't':
           switch (tokstr[2])
           {
             case 'A':
             case 'a':
               if ((tokstr[3] == 'N' || tokstr[3] == 'n'))
               {                                  /* ATAN      */
                 return ATAN;
               }

               goto unknown;

             case 'N':
             case 'n':
               {                                  /* ATN       */
                 return ATN;
               }

             default:
               goto unknown;
           }

         default:
           goto unknown;
       }

     case 'B':
     case 'b':
       switch (tokstr[1])
       {
         case 'A':
         case 'a':
           if ((tokstr[2] == 'S' || tokstr[2] == 's') &&
               (tokstr[3] == 'E' || tokstr[3] == 'e'))
           {                                      /* BASE      */
             return BASE;
           }

           goto unknown;

         case 'E':
         case 'e':
           if ((tokstr[2] == 'E' || tokstr[2] == 'e') &&
               (tokstr[3] == 'P' || tokstr[3] == 'p'))
           {                                      /* BEEP      */
             return BEEP;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'C':
     case 'c':
       switch (tokstr[1])
       {
         case 'D':
         case 'd':
           if ((tokstr[2] == 'B' || tokstr[2] == 'b') &&
               (tokstr[3] == 'L' || tokstr[3] == 'l'))
           {                                      /* CDBL      */
             return CDBL;
           }

           goto unknown;

         case 'H':
         case 'h':
           if ((tokstr[2] == 'R' || tokstr[2] == 'r') &&
               tokstr[3] == '$')
           {                                      /* CHR$      */
             return CHRSTRING;
           }

           goto unknown;

         case 'I':
         case 'i':
           if ((tokstr[2] == 'N' || tokstr[2] == 'n') &&
               (tokstr[3] == 'T' || tokstr[3] == 't'))
           {                                      /* CINT      */
             return CINT;
           }

           goto unknown;

         case 'L':
         case 'l':
           switch (tokstr[2])
           {
             case 'E':
             case 'e':
               if ((tokstr[3] == 'A' || tokstr[3] == 'a') &&
                   (tokstr[4] == 'R' || tokstr[4] == 'r'))
               {                                  /* CLEAR     */
                 return CLEAR;
               }

               goto unknown;

             case 'O':
             case 'o':
               if ((tokstr[3] == 'S' || tokstr[3] == 's') &&
                   (tokstr[4] == 'E' || tokstr[4] == 'e'))
               {                                  /* CLOSE     */
                 return CLOSE;
               }

               goto unknown;

             case 'S':
             case 's':
               {                                  /* CLS       */
                 return CLS;
               }

             default:
               goto unknown;
           }

         case 'O':
         case 'o':
           if ((tokstr[2] == 'S' || tokstr[2] == 's'))
           {                                      /* COS       */
             return COS;
           }

           goto unknown;

         case 'S':
         case 's':
           if ((tokstr[2] == 'N' || tokstr[2] == 'n') &&
               (tokstr[3] == 'G' || tokstr[3] == 'g'))
           {                                      /* CSNG      */
             return CSNG;
           }

           goto unknown;

         case 'V':
         case 'v':
           switch (tokstr[2])
           {
             case 'D':
             case 'd':
               {                                  /* CVD       */
                 return CVD;
               }

             case 'I':
             case 'i':
               {                                  /* CVI       */
                 return CVI;
               }

             case 'S':
             case 's':
               {                                  /* CVS       */
                 return CVS;
               }

             default:
               goto unknown;
           }

         default:
           goto unknown;
       }

     case 'D':
     case 'd':
       switch (tokstr[1])
       {
         case 'A':
         case 'a':
           switch (tokstr[2])
           {
             case 'T':
             case 't':
               switch (tokstr[3])
               {
                 case 'A':
                 case 'a':
                   {                              /* DATA      */
                     return DATA;
                   }

                 case 'E':
                 case 'e':
                   if (tokstr[4] == '$')
                   {                              /* DATE$     */
                     return DATESTRING;
                   }

                   goto unknown;

                 default:
                   goto unknown;
               }

             default:
               goto unknown;
           }

         case 'E':
         case 'e':
           switch (tokstr[2])
           {
             case 'F':
             case 'f':
               switch (tokstr[3])
               {
                 case 'D':
                 case 'd':
                   if ((tokstr[4] == 'B' || tokstr[4] == 'b') &&
                       (tokstr[5] == 'L' || tokstr[5] == 'l'))
                   {                              /* DEFDBL    */
                     return DEFDBL;
                   }

                   goto unknown;

                 case 'I':
                 case 'i':
                   if ((tokstr[4] == 'N' || tokstr[4] == 'n') &&
                       (tokstr[5] == 'T' || tokstr[5] == 't'))
                   {                              /* DEFINT    */
                     return DEFINT;
                   }

                   goto unknown;

                 case 'S':
                 case 's':
                   switch (tokstr[4])
                   {
                     case 'N':
                     case 'n':
                       if ((tokstr[5] == 'G' || tokstr[5] == 'g'))
                       {                          /* DEFSNG    */
                         return DEFSNG;
                       }

                       goto unknown;

                     case 'T':
                     case 't':
                       if ((tokstr[5] == 'R' || tokstr[5] == 'r'))
                       {                          /* DEFSTR    */
                         return DEFSTR;
                       }

                       goto unknown;

                     default:
                       goto unknown;
                   }

                 default:
                   return DEF; // manually added
                   //goto unknown;
               }

             default:
               goto unknown;
           }

         case 'I':
         case 'i':
           if ((tokstr[2] == 'M' || tokstr[2] == 'm'))
           {                                      /* DIM       */
             return DIM;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'E':
     case 'e':
       switch (tokstr[1])
       {
         case 'L':
         case 'l':
           if ((tokstr[2] == 'S' || tokstr[2] == 's') &&
               (tokstr[3] == 'E' || tokstr[3] == 'e'))
           {                                      /* ELSE      */
             return ELSE;
           }

           goto unknown;

         case 'N':
         case 'n':
           if ((tokstr[2] == 'D' || tokstr[2] == 'd'))
           {                                      /* END       */
             return END;
           }

           goto unknown;

         case 'O':
         case 'o':
           if ((tokstr[2] == 'F' || tokstr[2] == 'f'))
           {                                      /* EOF       */
             return xEOF; // manually modifed EOF -> xEOF
           }

           goto unknown;

         case 'Q':
         case 'q':
           if ((tokstr[2] == 'V' || tokstr[2] == 'v'))
           {                                      /* EQV       */
             return EQV;
           }

           goto unknown;

         case 'R':
         case 'r':
           switch (tokstr[2])
           {
             case 'A':
             case 'a':
               if ((tokstr[3] == 'S' || tokstr[3] == 's') &&
                   (tokstr[4] == 'E' || tokstr[4] == 'e'))
               {                                  /* ERASE     */
                 return ERASE;
               }

               goto unknown;

             case 'L':
             case 'l':
               {                                  /* ERL       */
                 return ERL;
               }

             case 'R':
             case 'r':
               switch (tokstr[3])
               {
                 case 'O':
                 case 'o':
                   if ((tokstr[4] == 'R' || tokstr[4] == 'r'))
                   {                              /* ERROR     */
                     return ERROR;
                   }

                   goto unknown;

                 default:
                   return ERR; // manually added
                   //goto unknown;
               }

             default:
               goto unknown;
           }

         case 'X':
         case 'x':
           if ((tokstr[2] == 'P' || tokstr[2] == 'p'))
           {                                      /* EXP       */
             return EXP;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'F':
     case 'f':
       switch (tokstr[1])
       {
         case 'I':
         case 'i':
           switch (tokstr[2])
           {
             case 'E':
             case 'e':
               if ((tokstr[3] == 'L' || tokstr[3] == 'l') &&
                   (tokstr[4] == 'D' || tokstr[4] == 'd'))
               {                                  /* FIELD     */
                 return FIELD;
               }

               goto unknown;

             case 'X':
             case 'x':
               {                                  /* FIX       */
                 return FIX;
               }

             default:
               goto unknown;
           }

         case 'O':
         case 'o':
           if ((tokstr[2] == 'R' || tokstr[2] == 'r'))
           {                                      /* FOR       */
             return FOR;
           }

           goto unknown;

         case 'R':
         case 'r':
           if ((tokstr[2] == 'E' || tokstr[2] == 'e'))
           {                                      /* FRE       */
             return FRE;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'G':
     case 'g':
       switch (tokstr[1])
       {
         case 'E':
         case 'e':
           if ((tokstr[2] == 'T' || tokstr[2] == 't'))
           {                                      /* GET       */
             return GET;
           }

           goto unknown;

         case 'O':
         case 'o':
           switch (tokstr[2])
           {
             case 'S':
             case 's':
               if ((tokstr[3] == 'U' || tokstr[3] == 'u') &&
                   (tokstr[4] == 'B' || tokstr[4] == 'b'))
               {                                  /* GOSUB     */
                 return GOSUB;
               }

               goto unknown;

             case 'T':
             case 't':
               if ((tokstr[3] == 'O' || tokstr[3] == 'o'))
               {                                  /* GOTO      */
                 return GOTO;
               }

               goto unknown;

             default:
               goto unknown;
           }

         default:
           goto unknown;
       }

     case 'H':
     case 'h':
       if ((tokstr[1] == 'E' || tokstr[1] == 'e') &&
           (tokstr[2] == 'X' || tokstr[2] == 'x') &&
           tokstr[3] == '$')
       {                                          /* HEX$      */
         return HEXSTRING;
       }

       goto unknown;

     case 'I':
     case 'i':
       switch (tokstr[1])
       {
         case 'F':
         case 'f':
           {                                      /* IF        */
             return IF;
           }

         case 'M':
         case 'm':
           if ((tokstr[2] == 'P' || tokstr[2] == 'p'))
           {                                      /* IMP       */
             return IMP;
           }

           goto unknown;

         case 'N':
         case 'n':
           switch (tokstr[2])
           {
             case 'K':
             case 'k':
               if ((tokstr[3] == 'E' || tokstr[3] == 'e') &&
                   (tokstr[4] == 'Y' || tokstr[4] == 'y') &&
                   tokstr[5] == '$')
               {                                  /* INKEY$    */
                 return INKEYSTRING;
               }

               goto unknown;

             case 'P':
             case 'p':
               switch (tokstr[3])
               {
                 case 'U':
                 case 'u':
                   switch (tokstr[4])
                   {
                     case 'T':
                     case 't':
                       switch (tokstr[5])
                       {
                         case '$':
                           {                      /* INPUT$    */
                             return INPUTSTRING;
                           }

                         default:
                            return INPUT; // manually added
                            // goto unknown;
                       }

                     default:
                       goto unknown;
                   }

                 default:
                   goto unknown;
               }

             case 'S':
             case 's':
               if ((tokstr[3] == 'T' || tokstr[3] == 't') &&
                   (tokstr[4] == 'R' || tokstr[4] == 'r'))
               {                                  /* INSTR     */
                 return INSTR;
               }

               goto unknown;

             case 'T':
             case 't':
               {                                  /* INT       */
                 return INT;
               }

             default:
               goto unknown;
           }

         default:
           goto unknown;
       }

     case 'L':
     case 'l':
       switch (tokstr[1])
       {
         case 'E':
         case 'e':
           switch (tokstr[2])
           {
             case 'F':
             case 'f':
               if ((tokstr[3] == 'T' || tokstr[3] == 't') &&
                   tokstr[4] == '$')
               {                                  /* LEFT$     */
                 return LEFTSTRING;
               }

               goto unknown;

             case 'N':
             case 'n':
               {                                  /* LEN       */
                 return LEN;
               }

             case 'T':
             case 't':
               {                                  /* LET       */
                 return LET;
               }

             default:
               goto unknown;
           }

         case 'I':
         case 'i':
           if ((tokstr[2] == 'N' || tokstr[2] == 'n') &&
               (tokstr[3] == 'E' || tokstr[3] == 'e'))
           {                                      /* LINE      */
             return LINE;
           }

           goto unknown;

         case 'O':
         case 'o':
           switch (tokstr[2])
           {
             case 'C':
             case 'c':
               switch (tokstr[3])
               {
                 case 'K':
                 case 'k':
                   {                              /* LOCK      */
                     return LOCK;
                   }

                 default:
                   return LOC; // manually added
                   // goto unknown;
               }

             case 'F':
             case 'f':
               {                                  /* LOF       */
                 return LOF;
               }

             case 'G':
             case 'g':
               {                                  /* LOG       */
                 return LOG;
               }

             default:
               goto unknown;
           }

         case 'S':
         case 's':
           if ((tokstr[2] == 'E' || tokstr[2] == 'e') &&
               (tokstr[3] == 'T' || tokstr[3] == 't'))
           {                                      /* LSET      */
             return LSET;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'M':
     case 'm':
       switch (tokstr[1])
       {
         case 'I':
         case 'i':
           if ((tokstr[2] == 'D' || tokstr[2] == 'd') &&
               tokstr[3] == '$')
           {                                      /* MID$      */
             return MIDSTRING;
           }

           goto unknown;

         case 'K':
         case 'k':
           switch (tokstr[2])
           {
             case 'D':
             case 'd':
               if (tokstr[3] == '$')
               {                                  /* MKD$      */
                 return MKDSTRING;
               }

               goto unknown;

             case 'I':
             case 'i':
               if (tokstr[3] == '$')
               {                                  /* MKI$      */
                 return MKISTRING;
               }

               goto unknown;

             case 'S':
             case 's':
               if (tokstr[3] == '$')
               {                                  /* MKS$      */
                 return MKSSTRING;
               }

               goto unknown;

             default:
               goto unknown;
           }

         case 'O':
         case 'o':
           if ((tokstr[2] == 'D' || tokstr[2] == 'd'))
           {                                      /* MOD       */
             return MOD;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'N':
     case 'n':
       switch (tokstr[1])
       {
         case 'E':
         case 'e':
           if ((tokstr[2] == 'X' || tokstr[2] == 'x') &&
               (tokstr[3] == 'T' || tokstr[3] == 't'))
           {                                      /* NEXT      */
             return NEXT;
           }

           goto unknown;

         case 'O':
         case 'o':
           if ((tokstr[2] == 'T' || tokstr[2] == 't'))
           {                                      /* NOT       */
             return NOT;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'O':
     case 'o':
       switch (tokstr[1])
       {
         case 'C':
         case 'c':
           if ((tokstr[2] == 'T' || tokstr[2] == 't') &&
               tokstr[3] == '$')
           {                                      /* OCT$      */
             return OCTSTRING;
           }

           goto unknown;

         case 'N':
         case 'n':
           {                                      /* ON        */
             return ON;
           }

         case 'P':
         case 'p':
           switch (tokstr[2])
           {
             case 'E':
             case 'e':
               if ((tokstr[3] == 'N' || tokstr[3] == 'n'))
               {                                  /* OPEN      */
                 return OPEN;
               }

               goto unknown;

             case 'T':
             case 't':
               if ((tokstr[3] == 'I' || tokstr[3] == 'i') &&
                   (tokstr[4] == 'O' || tokstr[4] == 'o') &&
                   (tokstr[5] == 'N' || tokstr[5] == 'n'))
               {                                  /* OPTION    */
                 return OPTION;
               }

               goto unknown;

             default:
               goto unknown;
           }

         case 'R':
         case 'r':
           {                                      /* OR        */
             return OR;
           }

         case 'U':
         case 'u':
           if ((tokstr[2] == 'T' || tokstr[2] == 't') &&
               (tokstr[3] == 'P' || tokstr[3] == 'p') &&
               (tokstr[4] == 'U' || tokstr[4] == 'u') &&
               (tokstr[5] == 'T' || tokstr[5] == 't'))
           {                                      /* OUTPUT    */
             return OUTPUT;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'P':
     case 'p':
       switch (tokstr[1])
       {
         case 'E':
         case 'e':
           if ((tokstr[2] == 'E' || tokstr[2] == 'e') &&
               (tokstr[3] == 'K' || tokstr[3] == 'k'))
           {                                      /* PEEK      */
             return PEEK;
           }

           goto unknown;

         case 'I':
         case 'i':
           {                                      /* PI        */
             return PI;
           }

         case 'O':
         case 'o':
           switch (tokstr[2])
           {
             case 'K':
             case 'k':
               if ((tokstr[3] == 'E' || tokstr[3] == 'e'))
               {                                  /* POKE      */
                 return POKE;
               }

               goto unknown;

             case 'S':
             case 's':
               {                                  /* POS       */
                 return POS;
               }

             case 'W':
             case 'w':
               {                                  /* POW       */
                 return POW;
               }

             default:
               goto unknown;
           }

         case 'R':
         case 'r':
           if ((tokstr[2] == 'I' || tokstr[2] == 'i') &&
               (tokstr[3] == 'N' || tokstr[3] == 'n') &&
               (tokstr[4] == 'T' || tokstr[4] == 't'))
           {                                      /* PRINT     */
             return PRINT;
           }

           goto unknown;

         case 'U':
         case 'u':
           if ((tokstr[2] == 'T' || tokstr[2] == 't'))
           {                                      /* PUT       */
             return PUT;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'R':
     case 'r':
       switch (tokstr[1])
       {
         case 'A':
         case 'a':
           switch (tokstr[2])
           {
             case 'N':
             case 'n':
               switch (tokstr[3])
               {
                 case 'D':
                 case 'd':
                   switch (tokstr[4])
                   {
                     case 'O':
                     case 'o':
                       switch (tokstr[5])
                       {
                         case 'M':
                         case 'm':
                           switch (tokstr[6])
                           {
                             case 'I':
                             case 'i':
                               if ((tokstr[7] == 'Z' || tokstr[7] == 'z') &&
                                   (tokstr[8] == 'E' || tokstr[8] == 'e'))
                               {                  /* RANDOMIZE */
                                 return RANDOMIZE;
                               }

                               goto unknown;

                             default:
                               goto unknown;
                           }

                         default:
                           goto unknown;
                       }

                     default:
                       goto unknown;
                   }

                 default:
                   goto unknown;
               }

             default:
               goto unknown;
           }

         case 'E':
         case 'e':
           switch (tokstr[2])
           {
             case 'A':
             case 'a':
               if ((tokstr[3] == 'D' || tokstr[3] == 'd'))
               {                                  /* READ      */
                 return READ;
               }

               goto unknown;

             case 'M':
             case 'm':
               {                                  /* REM       */
                 return REM;
               }

             case 'S':
             case 's':
               switch (tokstr[3])
               {
                 case 'T':
                 case 't':
                   if ((tokstr[4] == 'O' || tokstr[4] == 'o') &&
                       (tokstr[5] == 'R' || tokstr[5] == 'r') &&
                       (tokstr[6] == 'E' || tokstr[6] == 'e'))
                   {                              /* RESTORE   */
                     return RESTORE;
                   }

                   goto unknown;

                 case 'U':
                 case 'u':
                   if ((tokstr[4] == 'M' || tokstr[4] == 'm') &&
                       (tokstr[5] == 'E' || tokstr[5] == 'e'))
                   {                              /* RESUME    */
                     return RESUME;
                   }

                   goto unknown;

                 default:
                   goto unknown;
               }

             case 'T':
             case 't':
               if ((tokstr[3] == 'U' || tokstr[3] == 'u') &&
                   (tokstr[4] == 'R' || tokstr[4] == 'r') &&
                   (tokstr[5] == 'N' || tokstr[5] == 'n'))
               {                                  /* RETURN    */
                 return RETURN;
               }

               goto unknown;

             default:
               goto unknown;
           }

         case 'I':
         case 'i':
           if ((tokstr[2] == 'G' || tokstr[2] == 'g') &&
               (tokstr[3] == 'H' || tokstr[3] == 'h') &&
               (tokstr[4] == 'T' || tokstr[4] == 't') &&
               tokstr[5] == '$')
           {                                      /* RIGHT$    */
             return RIGHTSTRING;
           }

           goto unknown;

         case 'N':
         case 'n':
           if ((tokstr[2] == 'D' || tokstr[2] == 'd'))
           {                                      /* RND       */
             return RND;
           }

           goto unknown;

         case 'S':
         case 's':
           if ((tokstr[2] == 'E' || tokstr[2] == 'e') &&
               (tokstr[3] == 'T' || tokstr[3] == 't'))
           {                                      /* RSET      */
             return RSET;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'S':
     case 's':
       switch (tokstr[1])
       {
         case 'G':
         case 'g':
           if ((tokstr[2] == 'N' || tokstr[2] == 'n'))
           {                                      /* SGN       */
             return SGN;
           }

           goto unknown;

         case 'H':
         case 'h':
           if ((tokstr[2] == 'A' || tokstr[2] == 'a') &&
               (tokstr[3] == 'R' || tokstr[3] == 'r') &&
               (tokstr[4] == 'E' || tokstr[4] == 'e') &&
               (tokstr[5] == 'D' || tokstr[5] == 'd'))
           {                                      /* SHARED    */
             return SHARED;
           }

           goto unknown;

         case 'I':
         case 'i':
           if ((tokstr[2] == 'N' || tokstr[2] == 'n'))
           {                                      /* SIN       */
             return SIN;
           }

           goto unknown;

         case 'P':
         case 'p':
           switch (tokstr[2])
           {
             case 'A':
             case 'a':
               if ((tokstr[3] == 'C' || tokstr[3] == 'c') &&
                   (tokstr[4] == 'E' || tokstr[4] == 'e') &&
                   tokstr[5] == '$')
               {                                  /* SPACE$    */
                 return SPACESTRING;
               }

               goto unknown;

             case 'C':
             case 'c':
               {                                  /* SPC       */
                 return SPC;
               }

             default:
               goto unknown;
           }

         case 'Q':
         case 'q':
           if ((tokstr[2] == 'R' || tokstr[2] == 'r'))
           {                                      /* SQR       */
             return SQR;
           }

           goto unknown;

         case 'T':
         case 't':
           switch (tokstr[2])
           {
             case 'E':
             case 'e':
               if ((tokstr[3] == 'P' || tokstr[3] == 'p'))
               {                                  /* STEP      */
                 return STEP;
               }

               goto unknown;

             case 'O':
             case 'o':
               if ((tokstr[3] == 'P' || tokstr[3] == 'p'))
               {                                  /* STOP      */
                 return STOP;
               }

               goto unknown;

             case 'R':
             case 'r':
               switch (tokstr[3])
               {
                 case '$':
                   {                              /* STR$      */
                     return STRSTRING;
                   }

                 case 'I':
                 case 'i':
                   if ((tokstr[4] == 'N' || tokstr[4] == 'n') &&
                       (tokstr[5] == 'G' || tokstr[5] == 'g') &&
                       tokstr[6] == '$')
                   {                              /* STRING$   */
                     return STRINGSTRING;
                   }

                   goto unknown;

                 default:
                   goto unknown;
               }

             default:
               goto unknown;
           }

         case 'W':
         case 'w':
           if ((tokstr[2] == 'A' || tokstr[2] == 'a') &&
               (tokstr[3] == 'P' || tokstr[3] == 'p'))
           {                                      /* SWAP      */
             return SWAP;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'T':
     case 't':
       switch (tokstr[1])
       {
         case 'A':
         case 'a':
           switch (tokstr[2])
           {
             case 'B':
             case 'b':
               {                                  /* TAB       */
                 return TAB;
               }

             case 'N':
             case 'n':
               {                                  /* TAN       */
                 return TAN;
               }

             default:
               goto unknown;
           }

         case 'H':
         case 'h':
           if ((tokstr[2] == 'E' || tokstr[2] == 'e') &&
               (tokstr[3] == 'N' || tokstr[3] == 'n'))
           {                                      /* THEN      */
             return THEN;
           }

           goto unknown;

         case 'I':
         case 'i':
           switch (tokstr[2])
           {
             case 'M':
             case 'm':
               switch (tokstr[3])
               {
                 case 'E':
                 case 'e':
                   switch (tokstr[4])
                   {
                     case '$':
                       {                          /* TIME$     */
                         return TIMESTRING;
                       }

                     case 'R':
                     case 'r':
                       {                          /* TIMER     */
                         return TIMER;
                       }

                     default:
                       goto unknown;
                   }

                 default:
                   goto unknown;
               }

             default:
               goto unknown;
           }

         case 'O':
         case 'o':
           {                                      /* TO        */
             return TO;
           }

         case 'R':
         case 'r':
           switch (tokstr[2])
           {
             case 'O':
             case 'o':
               switch (tokstr[3])
               {
                 case 'F':
                 case 'f':
                   if ((tokstr[4] == 'F' || tokstr[4] == 'f'))
                   {                              /* TROFF     */
                     return TROFF;
                   }

                   goto unknown;

                 case 'N':
                 case 'n':
                   {                              /* TRON      */
                     return TRON;
                   }

                 default:
                   goto unknown;
               }

             default:
               goto unknown;
           }

         default:
           goto unknown;
       }

     case 'U':
     case 'u':
       switch (tokstr[1])
       {
         case 'N':
         case 'n':
           if ((tokstr[2] == 'L' || tokstr[2] == 'l') &&
               (tokstr[3] == 'O' || tokstr[3] == 'o') &&
               (tokstr[4] == 'C' || tokstr[4] == 'c') &&
               (tokstr[5] == 'K' || tokstr[5] == 'k'))
           {                                      /* UNLOCK    */
             return UNLOCK;
           }

           goto unknown;

         case 'S':
         case 's':
           if ((tokstr[2] == 'I' || tokstr[2] == 'i') &&
               (tokstr[3] == 'N' || tokstr[3] == 'n') &&
               (tokstr[4] == 'G' || tokstr[4] == 'g'))
           {                                      /* USING     */
             return USING;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'V':
     case 'v':
       switch (tokstr[1])
       {
         case 'A':
         case 'a':
           switch (tokstr[2])
           {
             case 'L':
             case 'l':
               switch (tokstr[3])
               {
                 case 'L':
                 case 'l':
                   if ((tokstr[4] == 'E' || tokstr[4] == 'e') &&
                       (tokstr[5] == 'N' || tokstr[5] == 'n'))
                   {                              /* VALLEN    */
                     return VALLEN;
                   }

                   goto unknown;

                 default:
                   goto unknown;
               }

             default:
               goto unknown;
           }

         default:
           goto unknown;
       }

     case 'W':
     case 'w':
       switch (tokstr[1])
       {
         case 'E':
         case 'e':
           if ((tokstr[2] == 'N' || tokstr[2] == 'n') &&
               (tokstr[3] == 'D' || tokstr[3] == 'd'))
           {                                      /* WEND      */
             return WEND;
           }

           goto unknown;

         case 'H':
         case 'h':
           if ((tokstr[2] == 'I' || tokstr[2] == 'i') &&
               (tokstr[3] == 'L' || tokstr[3] == 'l') &&
               (tokstr[4] == 'E' || tokstr[4] == 'e'))
           {                                      /* WHILE     */
             return WHILE;
           }

           goto unknown;

         case 'I':
         case 'i':
           if ((tokstr[2] == 'D' || tokstr[2] == 'd') &&
               (tokstr[3] == 'T' || tokstr[3] == 't') &&
               (tokstr[4] == 'H' || tokstr[4] == 'h'))
           {                                      /* WIDTH     */
             return WIDTH;
           }

           goto unknown;

         case 'R':
         case 'r':
           if ((tokstr[2] == 'I' || tokstr[2] == 'i') &&
               (tokstr[3] == 'T' || tokstr[3] == 't') &&
               (tokstr[4] == 'E' || tokstr[4] == 'e'))
           {                                      /* WRITE     */
             return WRITE;
           }

           goto unknown;

         default:
           goto unknown;
       }

     case 'X':
     case 'x':
       if ((tokstr[1] == 'O' || tokstr[1] == 'o') &&
           (tokstr[2] == 'R' || tokstr[2] == 'r'))
       {                                          /* XOR       */
         return XOR;
       }

       goto unknown;

     default:
       goto unknown;
   }

/* --------------------------------- PASTE -----------------------------------*/

unknown:
   return 0;
}
